#
# spec file for package drm
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

Url:            http://kernel.org/
%define sandybridge_only	0

Name:           drm
BuildRequires:  kernel-source kernel-syms module-init-tools
License:        GPL v2 only
Group:          System/Kernel
AutoReqProv:    on
Summary:        Backported agpgart and drm kernel modules
Version:        2.6.37
Release:        0.9.2
Source0:        linux-v2.6.37.tar.bz2
Source2:        Makefile
Source3:        Makefile-agp
# backport build fixes for DRM
Patch1:         001-drm-sysfs-revert.diff
Patch2:         002-drm-list-sort-revert.diff
Patch4:         004-radeon-i2c-fix-new-ops.diff
Patch6:         006-fb-apertures-alloc-revert.diff
Patch8:         008-revert-slowwork-conversion.diff
Patch9:         009-slow-work-oops-fix.diff
Patch10:        010-revert-shrinker-changes.diff
Patch11:        011-revert-fb-console-force-output.diff
Patch13:        013-in_dbg_master-hack.diff
Patch14:        014-revert-fb-debug-hooks.diff
Patch16:        016-dma_set_coherent_mask-hack.diff
Patch17:        017-intel-2.6.37-rc1-fixes.diff
Patch19:        019-revert-vzalloc.diff
# suse fixes
Patch20:        020-dont-enable-edp-when-lvds-is-present.diff
Patch23:        023-Revert-drm-radeon-Add-early-unregister-of-firmware-f.patch
Patch25:        025-revert-broken-vga-output-at-boot.diff
Patch32:        032-drm-i915-redetect-connections-at-resume.diff
Patch33:        033-drm-fix-fb-switch-after-s4.diff
Patch34:        034-drm-i915-Fix-calculation-of-backlight-value-in-combi.patch
# build fixes to be applied last
Patch97:        097-agp-build-fix.diff
Patch98:        sandybridge-only.diff
Patch99:        intel-agp-sandybridge-only.diff
# stable-kernel / upstream patches 
Patch100:       100-drm-radeon-kms-adjust-quirk-for-acer-laptop.patch
Patch101:       101-drm-radeon-kms-add-quirk-for-Mac-Radeon-HD-2600-card.patch
Patch102:       102-drm-Restore-the-old_fb-upon-modeset-failure.patch
Patch103:       103-drm-i915-check-eDP-encoder-correctly-when-setting-mo.patch
Patch104:       104-drm-i915-crt-Check-for-a-analog-monitor-in-case-of-D.patch
Patch105:       105-drm-i915-fix-calculation-of-eDP-signal-levels-on-San.patch
Patch106:       106-drm-i915-sdvo-Defer-detection-of-output-capabilities.patch
Patch107:       107-drm-i915-panel-Only-record-the-backlight-level-when-.patch
Patch108:       108-drm-Only-set-DPMS-ON-when-actually-configuring-a-mod.patch
Patch109:       109-drm-Add-an-interface-to-reset-the-device.patch
Patch110:       110-drm-i915-Reset-state-after-a-GPU-reset-or-resume.patch
Patch111:       111-drm-i915-crt-Force-the-initial-probe-after-reset.patch
Patch112:       112-drm-i915-Reset-crtc-after-resume.patch
Patch113:       113-drm-Don-t-switch-fb-when-disabling-an-output.patch
Patch114:       114-drm-Simplify-and-defend-later-checks-when-disabling-.patch
Patch115:       115-drm-Avoid-leak-of-adjusted-mode-along-quick-set_mode.patch
Patch116:       116-drm-i915-Only-bind-to-function-0-of-the-PCI-device.patch
Patch117:       117-drm-i915-Recognise-non-VGA-display-devices.patch
Patch118:       118-agp-ensure-GART-has-an-address-before-enabling-it.patch
Patch119:       119-drm-i915-lvds-Add-AOpen-i915GMm-HFS-to-the-list-of-f.patch
Patch120:       120-drm-i915-Invalidate-TLB-caches-on-SNB-BLT-BSD-rings.patch
Patch121:       121-drm-i915-sdvo-If-we-have-an-EDID-confirm-it-matches-.patch
Patch122:       122-drm-i915-tv-Use-polling-rather-than-interrupt-based-.patch
Patch123:       123-drm-i915-Fix-resume-regression-from-5d1d0cc.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%kernel_module_package default pae

%description
Backported agpgart and drm kernel modules, adding KMS support for Intel
SandyBridge.



Authors:
--------
    Authors of drviers/gpu/drm Linux Kernel subtree.

%package KMP
License:        GPL v2 only
Summary:        Backported agpgart and drm kernel modules
Group:          System/Kernel

%description KMP
Backported agpgart and drm kernel modules, adding KMS support for Intel
SandyBridge.



Authors:
--------
    Authors of drivers/gpu/drm Linux kernel subtree.

%prep
%setup -q -c -n %{name} -T -a 0
cp %{S:2} Makefile
cp %{S:3} drivers/char/agp/Makefile
cp /usr/src/linux/drivers/char/agp/agp.h drivers/char/agp
# stable kernel patches
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
# this regresses regarding a S4 bug on PineView
# %patch123 -p1
# build fixes
%patch1 -p1
%patch2 -p1
%patch4 -p1
%patch6 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1
%patch14 -p1
%patch16 -p1
%patch17 -p1
%patch19 -p1
# suse fixes
%patch20 -p1
%patch23 -p1
%patch25 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
# other build fixes
%patch97 -p1
%if 0%{sandybridge_only}
%patch98 -p1
%patch99 -p1
%endif
# get rid of tracing stuff (that makes the build harder)
echo "#ifndef __I915_TRACE_H
#define __I915_TRACE_H
#define trace_i915_gem_object_change_domain(a,b,c)
#define trace_i915_gem_request_retire(a,b)
#define trace_i915_gem_request_wait_begin(a,b)
#define trace_i915_gem_request_wait_end(a,b)
#define trace_i915_gem_object_unbind(a)
#define trace_i915_gem_object_get_fence(a,b,c)
#define trace_i915_gem_object_bind(a,b)
#define trace_i915_gem_object_clflush(a)
#define trace_i915_gem_object_create(a)
#define trace_i915_gem_object_destroy(a)
#define trace_i915_gem_request_complete(a,b)
#define trace_i915_gem_request_flush(a,b,c,d)
#define trace_i915_gem_request_submit(a,b)
#define trace_i915_ring_wait_begin(a)
#define trace_i915_ring_wait_end(a)
#define trace_i915_flip_complete(a,b)
#define trace_i915_flip_request(a,b)
#endif" > drivers/gpu/drm/i915/i915_trace.h
echo "i810.ko
savage.ko
via.ko
i830.ko
tdfx.ko
radeon.ko
ttm.ko
r128.ko
i915.ko
drm.ko
drm_kms_helper.ko
mga.ko
sis.ko
intel-gtt.ko
intel-agp.ko" > Module.supported
# use private headers
for i in $(find . -name Makefile); do
    echo 'NOSTDINC_FLAGS := -I$(M)/include -I$(M)/include/drm $(CFLAGS)' >> $i
done
set -- *
for flavor in %flavors_to_build; do
  mkdir build-$flavor
  cp -al "$@" build-$flavor
done

%build
for flavor in %flavors_to_build; do
  make %{?jobs:-j %jobs} -C /usr/src/linux-obj/%_target_cpu/$flavor \
    M=$(pwd)/build-$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
  make -C /usr/src/linux-obj/%_target_cpu/$flavor \
    M=$(pwd)/build-$flavor \
    modules_install
done

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Mar 25 2011 tiwai@suse.de
- 021-drm-keep-dpms-consistent.diff: Deleted, as this causes
  another regression on PineView (bnc#681134)
  DPMS consistency needs to be fixed differently.
* Mon Feb 21 2011 tiwai@suse.de
- Fix regression in backlight control on GM45 (bnc#672946)
* Mon Feb 21 2011 tiwai@suse.de
- Revert 123-drm-i915-Fix-resume-regression-from-5d1d0cc.patch
  as this regresses again regarding PineView S4
* Wed Feb 16 2011 tiwai@suse.de
- 120-drm-i915-Invalidate-TLB-caches-on-SNB-BLT-BSD-rings.patch,
  121-drm-i915-sdvo-If-we-have-an-EDID-confirm-it-matches-.patch,
  122-drm-i915-tv-Use-polling-rather-than-interrupt-based-.patch,
  123-drm-i915-Fix-resume-regression-from-5d1d0cc.patch:
  Backport stable fixes from v2.6.38-rc5
- Refreshed rest patches
* Mon Feb 14 2011 tiwai@suse.de
- Backport patches from upstream v2.6.38-rc3+
- 033-drm-fix-fb-switch-after-s4.diff:
  Fix fb breakage via hotplug after S4 (bnc#670311)
- 021-drm-keep-dpms-consistent.diff:
  Missing fix for S3/S4 in upstream fixes (bnc#659619)
* Mon Jan 31 2011 tiwai@suse.de
- 032-drm-i915-redetect-connections-at-resume.diff:
  Fix wrongly set-up fb via hotplug after S3/S4 (bnc#658764)
* Mon Jan 31 2011 tiwai@suse.de
- 031-drm-Simplify-and-defend-later-checks-when-disabling-.patch:
  Make VT-hang fix more robust (bnc#667231)
* Sat Jan 29 2011 tiwai@suse.de
- 030-drm-Don-t-switch-fb-when-disabling-an-output.patch:
  Fix hang-up with VT switch (bnc#667231)
* Mon Jan 24 2011 tiwai@suse.de
- Backported upstream fix patches by Chris Wilson
  (bnc#658764, bnc#664149)
* Fri Jan 21 2011 tiwai@suse.de
- Revised 026-fix-dpms-at-resume.diff
- 027-drm-i915-Fix-VGA-output-regression-upon-S3-resume.patch:
  Fix S3 resume problem with external monitor (bnc#658764)
- Remove unused preamble
* Fri Jan 21 2011 tiwai@suse.de
- 026-fix-dpms-at-resume.diff: Fix DPMS setup at resume
  (bnc#664149)
* Wed Jan 19 2011 tiwai@suse.de
- 025-revert-broken-vga-output-at-boot.diff: Fix LVDS status
  registers for PCH, eventually fixes the VGA output at cold boot
  (bnc#663581)
* Wed Jan 12 2011 tiwai@suse.de
- 100-drm-radeon-kms-adjust-quirk-for-acer-laptop.patch,
  101-drm-radeon-kms-add-quirk-for-Mac-Radeon-HD-2600-card.patch,
  102-drm-Restore-the-old_fb-upon-modeset-failure.patch,
  103-drm-i915-check-eDP-encoder-correctly-when-setting-mo.patch,
  104-drm-i915-crt-Check-for-a-analog-monitor-in-case-of-D.patch,
  105-drm-i915-fix-calculation-of-eDP-signal-levels-on-San.patch,
  106-drm-i915-sdvo-Defer-detection-of-output-capabilities.patch,
  107-drm-i915-panel-Only-record-the-backlight-level-when-.patch:
  Backport stable-kernel patches from 2.6.38-rc1 merge window
* Sun Jan  9 2011 sndirsch@novell.com
- 024-AOpen_i915GMm-HFS_mobo.diff
  * fix false detection of LVDS on AOpen i915GMm-HFS motherboard
* Sat Jan  8 2011 sndirsch@novell.com
- updated to linux-2.6.37
- adjusted 020-dont-enable-edp-when-lvds-is-present.diff
- removed obsolete
  022-Revert-drm-i915-bios-Reverse-order-of-100-120-Mhz-SS.patch
* Thu Dec 23 2010 tiwai@suse.de
- updated to linux-2.6.37-rc7+ (after pull of drm-fixes tree)
- add two reverts to fix build and regression (as in previous
  commit)
* Wed Dec 22 2010 tiwai@suse.de
- revert 0005-drm-i915-bios-Reverse-order-of-100-120-Mhz-SSC-clock.patch
  that results in blank LVDS on Heart.
* Wed Dec 22 2010 tiwai@suse.de
- patches from airlied/drm-2.6.git drm-fixes branch
* Tue Dec 21 2010 tiwai@suse.de
- Fix black screen with G33 by reverting the affecting patch
  (bko#25242)
- Clean up spec file, add some comments
* Thu Dec 16 2010 tiwai@suse.de
- drm: Recover DPMS properly after XRandr re-enablement
  (bnc#659619)
* Mon Dec 13 2010 tiwai@suse.de
- temporary fix for eDP / LVDS conflict on Fossil
* Thu Dec  9 2010 tiwai@suse.de
- linux-v2.6.37-rc5-62-g6313e3c:
  * obsoleted 018-intel-gtt-2.6.37-rc1-fixes.diff
  * obsoleted 023-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch
  * refreshed others
* Tue Dec  7 2010 sndirsch@novell.com
- no longer reverse apply 022-fix_for_hotplug_reporting.diff
  (kernel bug #24432)
- adjusted TODO
* Mon Dec  6 2010 sndirsch@novell.com
- reverse apply previous patch 022-fix_for_hotplug_reporting.diff
- readd previous patch
  023-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch
- adjusted TODO
* Fri Dec  3 2010 tiwai@suse.de
- linux-v2.6.37-rc4-153-g59e57c6
  * obsoletes previous
    020-force_dpmson_for_all_connectors_when_setting_new_crtc_config.diff
  * reenables previous 022-fix_for_hotplug_reporting.diff (TODO)
  * disables previous
    023-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch (TODO)
- adjusted patches
  * 004-radeon-i2c-fix-new-ops.diff
  * 008-revert-slowwork-conversion.diff
  * 010-revert-shrinker-changes.diff
  * 011-revert-fb-console-force-output.diff
  * 016-dma_set_coherent_mask-hack.diff
- renamed patches
  * 024-Revert-drivers-gpu-Use-vzalloc.patch -->
    019-revert-vzalloc.diff (adjusted)
  * 025-agp-build-fix.diff --> 097-agp-build-fix.diff (adjusted)
- added TODO
* Tue Nov 30 2010 tiwai@suse.de
- renamed from intel-drm-kmp-* to drm-kmp-*
* Mon Nov 29 2010 tiwai@suse.de
- disable 022-fix_for_hotplug_reporting.diff, as it breaks
  externa-only mode via Fn-F4.
* Mon Nov 29 2010 tiwai@suse.de
- fix oops with IronLake
- refresh fuzzy patches
* Thu Nov 25 2010 tiwai@suse.de
- disable set_pages_attr_wc hack, requiring the new kernel
* Thu Nov 25 2010 sndirsch@novell.com
- no longer build for SandyBridge only, i.e. enable support also
  for other Intel GPUs
* Wed Nov 24 2010 sndirsch@novell.com
- removed 019-drm-i915-Fix-hangcheck-to-handle-multiple-rings.patch
* Wed Nov 24 2010 sndirsch@novell.com
- intel-drm-fixes 20101123-0c1dab8
- obsoletes fix_for_VGA_flickering.diff
- adjusted 017-intel-2.6.37-rc1-fixes.diff
- 024-Revert-drivers-gpu-Use-vzalloc.patch
  * Revert "drivers/gpu: Use vzalloc" (to fix build)
- renamed a bunch of patches
  * 0001-drm-i915-Fix-hangcheck-to-handle-multiple-rings.patch -->
    019-drm-i915-Fix-hangcheck-to-handle-multiple-rings.patch
  * force_dpmson_for_all_connectors_when_setting_new_crtc_config.diff -->
    020-force_dpmson_for_all_connectors_when_setting_new_crtc_config.diff
  * fix_for_hotplug_reporting.diff -->
    022-fix_for_hotplug_reporting.diff
  * 0001-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch -->
    023-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch
* Fri Nov 19 2010 sndirsch@novell.com
- 0001-drm-i915-Always-set-the-DP-transcoder-config-to-8BPC.patch
  * fixes Displayport support
* Wed Nov 17 2010 sndirsch@novell.com
- force_dpmson_for_all_connectors_when_setting_new_crtc_config.diff
  * When setting a new crtc configuration, force the DPMS state of
    all connectors to ON. Otherwise, they'll be left at OFF and a
    future mode set that disables the specified connector will not
    turn the connector off. (bnc #647274)
- fix_for_VGA_flickering.diff
  * Both IBX and CPT have an automatic hotplug detection mode which
    appears to work reliably enough that we can dispense with the
    manual force hotplug trigger stuff. This means that hotplug
    detection is as simple as reading the current hotplug register
    values.
    The first time the hotplug detection is activated, the code
    synchronously waits for a hotplug sequence in case the hardware
    hasn't bothered to do a detection cycle since being initialized.
- fix_for_hotplug_reporting.diff
  * In order to correctly report monitor connected status changes,
    the previous monitor status must be recorded in the
    connector->status value instead of being discarded.
* Thu Nov 11 2010 sndirsch@novell.com
- prepared build for drm-intel-next;
  010-revert-shrinker-changes.diff/017-intel-2.6.37-rc1-fixes.diff
  still needs to be adjusted or are (partly) obsolete, new patches
  need to be added to fix build
* Thu Nov 11 2010 sndirsch@novell.com
- 0001-drm-i915-Fix-hangcheck-to-handle-multiple-rings.patch
  * drm/i915: Fix hangcheck to handle multiple rings (kernel bug
    [#22752])
* Wed Nov 10 2010 sndirsch@novell.com
- switched to intel-drm-fixes branch (20101110-6966945)
- fixes broken 2D/3D rendering (bfo #31524)
- obsoletes the following patches
  * 0001-agp-intel-restore-cache-behavior-on-sandybridge.patch
  * 0001-drm-i915-Apply-big-hammer-to-serialise-buffer-access.patch
  * 0001-drm-i915-Fix-KMS-regression-on-Sandybridge-CPT.patch
  * 019-intel-gtt-gen6-pte-flags-fix.diff
* Wed Nov 10 2010 sndirsch@novell.com
- 0001-agp-intel-restore-cache-behavior-on-sandybridge.patch
  * possibly supposed to fix the incorrect caching of the scanout,
    but made things worse (bfo #31524)
* Wed Nov 10 2010 sndirsch@novell.com
- 0001-drm-i915-Apply-big-hammer-to-serialise-buffer-access.patch
  * possibly supposed to fix virtual corruption with OpenGL
    applications, but it turned out that it doesn't (bfo #31524)
* Wed Nov 10 2010 sndirsch@novell.com
- 0001-drm-i915-Fix-KMS-regression-on-Sandybridge-CPT.patch
  * fixes black screen on SugarBay platform, which turned out to
    be a KMS regression bug
* Wed Nov  3 2010 tiwai@suse.de
- fix intel-gtt
* Wed Nov  3 2010 sndirsch@novell.com
- preamble: Provides/Obsoletes intel-agp-kmp
* Wed Nov  3 2010 tiwai@suse.de
- build intel-agp here as well since intel-drm requires intel-gtt
  module
* Tue Nov  2 2010 tiwai@suse.de
- 2.6.37-rc1
* Mon Oct 25 2010 tiwai@suse.de
- 2.6.36-final
- Backport DisplayPort/HDMI audio patcehs (bnc#647497)
* Tue Oct 19 2010 tiwai@suse.de
- 2.6.36-rc8
* Tue Oct  5 2010 tiwai@suse.de
- 2.6.36-rc6-119
* Mon Oct  4 2010 tiwai@suse.de
- 2.6.36-rc6-84; including a few drm/i915 fixes
* Wed Sep 29 2010 tiwai@suse.de
- 2.6.36-rc6
* Mon Sep 27 2010 tiwai@suse.de
- updated to 2.6.36-rc5-151
- sandybridge only
* Tue Aug 31 2010 tiwai@suse.de
- updated to 2.6.36-rc3
* Fri Aug 20 2010 tiwai@suse.de
- updated 2.6.36-rc1
- fixed forgotten sysfs and shrinker changes
* Tue Aug 17 2010 tiwai@suse.de
- add new id 8086:0116
* Tue Aug  3 2010 tiwai@suse.de
- updated to linux-2.6.35 final
* Fri Jul 23 2010 tiwai@suse.de
- updated to linux-2.6.35-rc6
* Mon Jul 12 2010 tiwai@suse.de
- updated to linux-2.6.35-rc4 plus (almsot rc5); hibernation fix
  patch is already included
* Mon Jun 21 2010 tiwai@suse.de
- fix Oops in delayed_slow_work_enqueue()
* Mon Jun 14 2010 tiwai@suse.de
- updated to linux-2.6.35-rc3
* Thu May 27 2010 tiwai@suse.de
- updated to linux-2.6.34 final
* Tue May 11 2010 tiwai@suse.de
- updated to linux-2.6.34-rc7
* Sun Apr 25 2010 tiwai@suse.de
- fix patch from Intel:
  https://bugzilla.novell.com/show_bug.cgi?id=567723#c123
* Thu Apr 22 2010 tiwai@suse.de
- adhoc ironlake s4 VGA fix
* Tue Apr 20 2010 tiwai@suse.de
- updated to v2.6.35-rc5
- build only pae
* Fri Apr  9 2010 tiwai@suse.de
- updated to v2.6.34-rc3-410-gd620a7c
* Mon Mar 29 2010 tiwai@suse.de
- initial version
